// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v5.26.1
// source: game_stats.proto

package gamestatsclient

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	GameStats_UpdateGameMetadata_FullMethodName      = "/gamestats.GameStats/UpdateGameMetadata"
	GameStats_UpdateTeamStats_FullMethodName         = "/gamestats.GameStats/UpdateTeamStats"
	GameStats_UpdateCombinedGameStats_FullMethodName = "/gamestats.GameStats/UpdateCombinedGameStats"
	GameStats_GetGameStats_FullMethodName            = "/gamestats.GameStats/GetGameStats"
	GameStats_MonitorGameStats_FullMethodName        = "/gamestats.GameStats/MonitorGameStats"
)

// GameStatsClient is the client API for GameStats service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type GameStatsClient interface {
	UpdateGameMetadata(ctx context.Context, in *GameMetadata, opts ...grpc.CallOption) (*EmptyRequest, error)
	UpdateTeamStats(ctx context.Context, in *TeamStats, opts ...grpc.CallOption) (*EmptyRequest, error)
	UpdateCombinedGameStats(ctx context.Context, in *CombinedGameStats, opts ...grpc.CallOption) (*EmptyRequest, error)
	GetGameStats(ctx context.Context, in *EmptyRequest, opts ...grpc.CallOption) (*CombinedGameStats, error)
	MonitorGameStats(ctx context.Context, in *EmptyRequest, opts ...grpc.CallOption) (GameStats_MonitorGameStatsClient, error)
}

type gameStatsClient struct {
	cc grpc.ClientConnInterface
}

func NewGameStatsClient(cc grpc.ClientConnInterface) GameStatsClient {
	return &gameStatsClient{cc}
}

func (c *gameStatsClient) UpdateGameMetadata(ctx context.Context, in *GameMetadata, opts ...grpc.CallOption) (*EmptyRequest, error) {
	out := new(EmptyRequest)
	err := c.cc.Invoke(ctx, GameStats_UpdateGameMetadata_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *gameStatsClient) UpdateTeamStats(ctx context.Context, in *TeamStats, opts ...grpc.CallOption) (*EmptyRequest, error) {
	out := new(EmptyRequest)
	err := c.cc.Invoke(ctx, GameStats_UpdateTeamStats_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *gameStatsClient) UpdateCombinedGameStats(ctx context.Context, in *CombinedGameStats, opts ...grpc.CallOption) (*EmptyRequest, error) {
	out := new(EmptyRequest)
	err := c.cc.Invoke(ctx, GameStats_UpdateCombinedGameStats_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *gameStatsClient) GetGameStats(ctx context.Context, in *EmptyRequest, opts ...grpc.CallOption) (*CombinedGameStats, error) {
	out := new(CombinedGameStats)
	err := c.cc.Invoke(ctx, GameStats_GetGameStats_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *gameStatsClient) MonitorGameStats(ctx context.Context, in *EmptyRequest, opts ...grpc.CallOption) (GameStats_MonitorGameStatsClient, error) {
	stream, err := c.cc.NewStream(ctx, &GameStats_ServiceDesc.Streams[0], GameStats_MonitorGameStats_FullMethodName, opts...)
	if err != nil {
		return nil, err
	}
	x := &gameStatsMonitorGameStatsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type GameStats_MonitorGameStatsClient interface {
	Recv() (*CombinedGameStats, error)
	grpc.ClientStream
}

type gameStatsMonitorGameStatsClient struct {
	grpc.ClientStream
}

func (x *gameStatsMonitorGameStatsClient) Recv() (*CombinedGameStats, error) {
	m := new(CombinedGameStats)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// GameStatsServer is the server API for GameStats service.
// All implementations must embed UnimplementedGameStatsServer
// for forward compatibility
type GameStatsServer interface {
	UpdateGameMetadata(context.Context, *GameMetadata) (*EmptyRequest, error)
	UpdateTeamStats(context.Context, *TeamStats) (*EmptyRequest, error)
	UpdateCombinedGameStats(context.Context, *CombinedGameStats) (*EmptyRequest, error)
	GetGameStats(context.Context, *EmptyRequest) (*CombinedGameStats, error)
	MonitorGameStats(*EmptyRequest, GameStats_MonitorGameStatsServer) error
	mustEmbedUnimplementedGameStatsServer()
}

// UnimplementedGameStatsServer must be embedded to have forward compatible implementations.
type UnimplementedGameStatsServer struct {
}

func (UnimplementedGameStatsServer) UpdateGameMetadata(context.Context, *GameMetadata) (*EmptyRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateGameMetadata not implemented")
}
func (UnimplementedGameStatsServer) UpdateTeamStats(context.Context, *TeamStats) (*EmptyRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateTeamStats not implemented")
}
func (UnimplementedGameStatsServer) UpdateCombinedGameStats(context.Context, *CombinedGameStats) (*EmptyRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateCombinedGameStats not implemented")
}
func (UnimplementedGameStatsServer) GetGameStats(context.Context, *EmptyRequest) (*CombinedGameStats, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetGameStats not implemented")
}
func (UnimplementedGameStatsServer) MonitorGameStats(*EmptyRequest, GameStats_MonitorGameStatsServer) error {
	return status.Errorf(codes.Unimplemented, "method MonitorGameStats not implemented")
}
func (UnimplementedGameStatsServer) mustEmbedUnimplementedGameStatsServer() {}

// UnsafeGameStatsServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to GameStatsServer will
// result in compilation errors.
type UnsafeGameStatsServer interface {
	mustEmbedUnimplementedGameStatsServer()
}

func RegisterGameStatsServer(s grpc.ServiceRegistrar, srv GameStatsServer) {
	s.RegisterService(&GameStats_ServiceDesc, srv)
}

func _GameStats_UpdateGameMetadata_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GameMetadata)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(GameStatsServer).UpdateGameMetadata(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: GameStats_UpdateGameMetadata_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(GameStatsServer).UpdateGameMetadata(ctx, req.(*GameMetadata))
	}
	return interceptor(ctx, in, info, handler)
}

func _GameStats_UpdateTeamStats_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TeamStats)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(GameStatsServer).UpdateTeamStats(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: GameStats_UpdateTeamStats_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(GameStatsServer).UpdateTeamStats(ctx, req.(*TeamStats))
	}
	return interceptor(ctx, in, info, handler)
}

func _GameStats_UpdateCombinedGameStats_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CombinedGameStats)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(GameStatsServer).UpdateCombinedGameStats(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: GameStats_UpdateCombinedGameStats_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(GameStatsServer).UpdateCombinedGameStats(ctx, req.(*CombinedGameStats))
	}
	return interceptor(ctx, in, info, handler)
}

func _GameStats_GetGameStats_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(EmptyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(GameStatsServer).GetGameStats(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: GameStats_GetGameStats_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(GameStatsServer).GetGameStats(ctx, req.(*EmptyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _GameStats_MonitorGameStats_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(EmptyRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(GameStatsServer).MonitorGameStats(m, &gameStatsMonitorGameStatsServer{stream})
}

type GameStats_MonitorGameStatsServer interface {
	Send(*CombinedGameStats) error
	grpc.ServerStream
}

type gameStatsMonitorGameStatsServer struct {
	grpc.ServerStream
}

func (x *gameStatsMonitorGameStatsServer) Send(m *CombinedGameStats) error {
	return x.ServerStream.SendMsg(m)
}

// GameStats_ServiceDesc is the grpc.ServiceDesc for GameStats service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var GameStats_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "gamestats.GameStats",
	HandlerType: (*GameStatsServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "UpdateGameMetadata",
			Handler:    _GameStats_UpdateGameMetadata_Handler,
		},
		{
			MethodName: "UpdateTeamStats",
			Handler:    _GameStats_UpdateTeamStats_Handler,
		},
		{
			MethodName: "UpdateCombinedGameStats",
			Handler:    _GameStats_UpdateCombinedGameStats_Handler,
		},
		{
			MethodName: "GetGameStats",
			Handler:    _GameStats_GetGameStats_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "MonitorGameStats",
			Handler:       _GameStats_MonitorGameStats_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "game_stats.proto",
}
